Description:
Given an array of integers where 1≤a[i]≤n (n = size of array), some elements appear twice and others appear once.
Find all the elements of [1, N] inclusive the does not appear in this array.
Could do it without extra space and in O (n) runtime? Assume the returned list does not count as extra space.
Example:
input:[4,3,2,7,8,2,3,1]output:[5,6]
My Solution:
classSolution { PublicList<integer> Finddisappearednumbers (int[] nums) { intLen1 =nums.length; Set<Integer> set =NewHashset<integer>(); Set<Integer> Set1 =NewHashset<integer>(); for(inti = 0;i < len1;i++) {Set.add (integer.valueof (i+ 1)); Set1.add (integer.valueof (nums[i)); } set.removeall (Set1); return NewArraylist<integer>(set); }}
Another Better solution:
Public classSolution { PublicList<integer> Finddisappearednumbers (int[] nums) {List<Integer> list =NewArraylist<>(); Boolean[] A =New Boolean[Nums.length + 1]; for(inti = 0; i < nums.length; i++) {A[nums[i]]=true; } for(inti = 1; i < a.length; i++) { if(!A[i]) {list.add (i); } }
returnlist; }}
Summary: Create a Boolean array that corresponds to the subscript true to indicate that the numeric value exists, false to indicate that it does not exist, traverse Nums, and assign the Nums value as subscript to true. Traversing a Boolean array, the subscript for the value of false is not present, add to ArrayList (note that the length of the Boolean array is the length of the Nums plus one, convenient for one by one correspondence).
It is important to observe that the Nums value is subscript with a Boolean array.
Leetcode-find all Numbers disappeared in an Array